
alert("init.js loaded.");
var bootingTimeInitial = 0;
var resolutionWidth = 720;
var resolutionHeight = 1280;
var filesPerRow;
var tvYear;

//Entry point to the application
function onStart() {
	bootingTimeInitial = new Date().getTime();

	alert("Resolution: " + sf.env.getResolution());
	//set the number of elements in the grid row depending the resolution
	switch (sf.env.getResolution()) {
	case '540p':
		filesPerRow = 5;
		break;
	case '720p':
		filesPerRow = 7;
		break;
	case '1080p':
		filesPerRow = 7;
		break;
	}

	// include file
	var arrPathToIncluded = new Array();
	arrPathToIncluded.push('app/Controller.js');
	tvYear = sf.env.getFirmwareVer().year;

	if (tvYear ==  null && navigator.userAgent.indexOf("Gecko") != -1)
		tvYear = "2011";

  //Change app language
	var lang = sf.core.getEnvValue('lang') || sf.env.getLanguageCode() ||
		deviceapis.tv.info.getLanguage();
	alert("lang: " + lang);
	switch (lang) {
	case 'es':
	case 'es-US':
		sf.core.loadJS('lang/es.js');
		break;
	default:
		sf.core.loadJS('lang/en.js');
		break;
	}

	sf.core.loadJS(arrPathToIncluded, function () {
		controller.initialize();

		alert("first value: " + sf.core.localData("first"));
		if (sf.core.localData(
				"first") == undefined || sf.core.localData("first") == null ||
			!sf.core.localData("first")) {
			alert("first time " + tvYear);
			sf.core.localData("first", true);
		} else {
			alert("first time false");
			sf.core.localData("first", false);
		}
		controller.start();
	});

}

function onDestroy() {
	// stop your XHR or Ajax operation and put codes to distroy your application here
	alert("App destroy: " + tvYear);

	if (storage.getValue("keepLoggedIn") != 1 && storage.getValue("keepLoggedIn") != "yes") {
		controller.logout();
	}

}
