function SceneImageScene(options) {
	this.options = options;
}
var imagePos;
var imageArray;
var imageUrl;
var stop;
var playing;
var retry;
var printer;
var lastTimeButtonPressed;
var imageTimeStart;
var imageTimeEnd;
var loading;
var imageRotation;
var imgElement;
SceneImageScene.prototype.initialize = function () {
	alert("SceneImageScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	//NAvigation help:
	stop = true;

}

SceneImageScene.prototype.handleShow = function () {
	alert("SceneImageScene.handleShow()");
	// this function will be called when the scene manager show this scene
	printer = window.deviceapis.printer || {};
	pos = currentFocused - fold.length;
	alert(imageFiles.length);
	for (var i = 0; i < imageFiles.length; i++) {
		if (imageFiles[i].title == folderFiles[pos].title) {
			alert("imagepos: " + i);
			imagePos = i;
		}
	}
	stop = true;
	retry = false;
	imageArray = new Array();
	imageUrl = new Array();
	$('#svecKeyHelp_image').sfKeyHelp({
		'user' : states.username,
		'play' : 'Play slideshow',
		'info' : STR_FILE_INFO,
		'leftright' : 'LeftRight',
		'return' : 'Back'

	});
	$('#openFile').css('visibility', 'visible');
	$('#openFileBackground').css('visibility', 'visible');
	$('#image').css('visibility', 'visible');

	setTimeout("$('#svecKeyHelp_image').css('visibility', 'hidden')", 3000);
	sf.key.unregisterKey(sf.key.UP);
	sf.key.unregisterKey(sf.key.DOWN);
	loading = false;
	imageRotation = "none";
	imgElement = document.getElementById("image");
}

SceneImageScene.prototype.handleHide = function () {
	alert("SceneImageScene.handleHide()");
	// this function will be called when the scene manager hide this scene
	imagePos = null;

	imageUrl = null;
	stop = null;
	retry = null;
	printer = null;
	lastTimeButtonPressed = null;
	for (var i in imageArray) {
		alert("i " + i);
		imageArray[i] = null;
		delete imageArray[i];
	}
	delete(imageArray);
	delete(imageUrl);
	$('#image').html('');
	//	imageArray = null;
	pluginAPI.setOnScreenSaver();
	sf.key.registerKey(sf.key.UP);
	sf.key.registerKey(sf.key.DOWN);
}

SceneImageScene.prototype.handleFocus = function () {
	alert("SceneImageScene.handleFocus()");
	// this function will be called when the scene manager focus this scene

	$('#loadingImage').sfLoading('show');

	SceneImageScene.loadImage();
	playing = false;

}

SceneImageScene.prototype.handleBlur = function () {
	alert("SceneImageScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene

}

SceneImageScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneImageScene.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued

	alert("imagePos " + imagePos + "     imageArray" + imageArray.length);
	$('#svecKeyHelp_image').css('visibility', 'visible');
	setTimeout("SceneImageScene.hideHelpBar()", 3000);
	lastTimeButtonPressed = Date.now();
	switch (keyCode) {
	case sf.key.LEFT:
		if (imagePos == 0) {
			imagePos = imageFiles.length - 1;
		} else {
			imagePos--;
		}
		SceneImageScene.loadImage();
		break;
	case sf.key.RIGHT:
		if (imagePos == (imageFiles.length - 1)) {
			imagePos = 0;
		} else {
			imagePos++;
		}
		alert("right pos: " + imagePos);
		SceneImageScene.loadImage();
		break;
	case sf.key.ENTER:
		break;
	case sf.key.UP:
		alert("UP");
		sf.key.preventDefault();
		break;
	case sf.key.DOWN:
		alert("DOWN");
		sf.key.preventDefault();
		break;

	case sf.key.PLAY:
		//Start Slideshow
		$('#svecKeyHelp_image').sfKeyHelp({
			'user' : states.username,
			'stop' : 'Stop slideshow',
			'leftright' : 'LeftRight',
			'return' : 'Back'

		});
		pluginAPI.setOffScreenSaver();
		playing = true;
		alert("stop: " + stop);
		stop = false;
		alert("stop: " + stop + "  " + this.stop);

		(function loop() {
			setTimeout(function () {

				// logic here
				alert("stop: " + stop);
				imageTimeEnd = new Date().getTime();
				alert("imageTimeEnd " + imageTimeEnd + "    imageTimeStart " + imageTimeStart);
				if (imageTimeEnd - imageTimeStart > 5000 && !loading) {
					SceneImageScene.slideshow();
				}
				if (stop == false) {
					// recurse
					loop();
				}

			}, 500);
		})();
		break;

	case sf.key.STOP:
		//stop slideshow
		$('#svecKeyHelp_image').sfKeyHelp({
			'user' : states.username,
			'play' : 'Play slideshow',
			/*  'blue': 'Print',*/
			'info' : STR_FILE_INFO,
			'leftright' : 'LeftRight',
			'return' : 'Back'

		});
		pluginAPI.setOnScreenSaver();
		playing = false;
		$('#loadingImage').sfLoading('hide');
		stop = true;
		alert("stop " + stop);
		break;

/*	case sf.key.BLUE:
		alert('pressed KEY_BLUE');
		if (printer.isPrintingServiceSupported()) {
			alert('there is printer module');
			var l = imageFiles[imagePos].url || imageFiles[imagePos].href; //different browser handles it in different way
			var link = l + "/" + imageFiles[imagePos].title;
			link = baxide.generateUrl(link);
			alert("printing: " + link);
			printer.runFilePrinting(link);
		} else {
			alert('there is no printer module');
			//popup
			$('#printerPopUp').sfPopup({
				text : STR_PRINTER_POPUP,
				buttons : ["Ok"],
				defaultFocus : 0,
				callback : function callback() {}
			});
			$('#printerPopUp').sfPopup('show');
		}
		break;
*/
	case sf.key.RETURN:
		//if($("#openFile").css('visibility') == 'visible'){
		alert("hide image");
		$('#openFile').css('visibility', 'hidden');
		$('#openFileBackground').css('visibility', 'hidden');
		$('#image').css('visibility', 'hidden');
		$('#image').empty();
		$('#loadingImage').sfLoading('hide');
		//}else{
		alert("hide scene");

		sf.scene.hide('ImageScene');
		sf.scene.focus('DriveScene', true);

		//}

		sf.key.preventDefault();
		break;

	case sf.key.INFO: // display the info of a file
		alert("INFO");
		if (currentFocused >= fold.length) {

			alert("Is a File");
			pos = currentFocused - fold.length;
			alert("file " + folderFiles[pos].title + " is a " + folderFiles[pos].type);
			alert("FILE mime: " + folderFiles[pos].mime);
			alert("FILE updated: " + folderFiles[pos].updated);
			alert("camera make: " + folderFiles[pos].camera);
			alert("camera make: " + folderFiles[pos].camera_model);
			alert("camera make: " + imageFiles[imagePos].camera);
			alert("camera make: " + imageFiles[imagePos].camera_model);
			$('#imageInfo_popup').sfPopup({
				text : STR_TITLE + ": " + imageFiles[imagePos].title + " </br> " + STR_UPDATED + ": " + imageFiles[imagePos].updated + "</br>" + STR_SIZE + ": " + imageFiles[imagePos].size + "</br>" + STR_CAMERA + ": " + imageFiles[imagePos].camera + "</br>" + STR_MODEL + ": " + imageFiles[imagePos].camera_model + "</br> Flash: " + imageFiles[imagePos].flash + "</br> dpi: " + imageFiles[imagePos].dpi + "</br> ISO: " + imageFiles[imagePos].iso + "</br> Focal: " + imageFiles[imagePos].focal + "</br>" + STR_APERTURE + ": " + imageFiles[imagePos].aperture + "</br>" + STR_EXPOSURE + ": " + imageFiles[imagePos].exposure,
				buttons : ["Ok"],
				defaultFocus : 0,
				timeout : 0,
				callback : function newFolderCallback(selectedIndex) {}
			});

			$('#imageInfo_popup').sfPopup('show');
		}
		break;
	case sf.key.VOL_UP:
		alert("Vol up");
		deviceapis.audiocontrol.setVolumeUp();
		//	this.showVolume();

		//    if(Player.getState() != Player.PAUSED)
		//       Player.skipBackwardVideo();
		break;
	case sf.key.VOL_DOWN:
		alert("Vol down");
		deviceapis.audiocontrol.setVolumeDown();

		//	this.showVolume();
		//    if(Player.getState() != Player.PAUSED)
		//       Player.skipBackwardVideo();
		break;
	case sf.key.MUTE:
		alert("MUTE");
		if (deviceapis.audiocontrol.getMute() == true) {
			deviceapis.audiocontrol.setMute(false);
		} else {
			deviceapis.audiocontrol.setMute(true);
		}
		break;
	}
}

//Displays the image in the screen.
SceneImageScene.showImage = function () {
	alert("show image: " + imagePos);
	alert("orientation: " + imageFiles[imagePos].orientation);
	alert("src: " + imageArray[imagePos].src);
	//	$('#image').html('');
	try {
		alert("frist child: " + imgElement.firstChild);
		if (imgElement.firstChild != null) {
			if (imgElement.deleteChild && tvYear != "2011") {
				imgElement.deleteChild(imgElement.firstChild);
			} else {
				var del = imgElement.removeChild(imgElement.firstChild);
			}
		}
	} catch (e) {
		alert("error removing img from DOM: " + e);
	}
	alert("frist child: " + imgElement.firstChild);
	if ($('#blackdiv').length > 0)
		$('#blackdiv').remove();

	$('#image').css('top', 0);
	$('#image').css('visibility', 'hidden');
	$('#loadingImage').sfLoading('hide');
	alert("load hidden");
	if (imageArray[imagePos] != "loading" && imageArray[imagePos] != undefined) {
		alert("image array " + imageArray);
		//$('#image').html(imageArray[imagePos]);
		/*		if(tvYear =="2011"){
		//imgElement.appendChild("");
		alert(document.getElementById('imgCanvas'));
		var canvas = document.getElementById('imgCanvas');
		canvas.width =  imageArray[imagePos].width;
		canvas.height =  imageArray[imagePos].height;
		alert(canvas);
		var context = canvas.getContext('2d');
		context.drawImage(imageArray[imagePos],0,0, imageArray[imagePos].width, imageArray[imagePos].height);
		//			}
		if(tvYear =="2012")*/
		imgElement.appendChild(imageArray[imagePos]);
	} else {
		alert("image url:")
		$('#image').html("<img src='" + imageUrl[imagePos] + "'/>");
	}

	$('#image').load(SceneImageScene.setPosition());
	switch (imageFiles[imagePos].orientation) {
	case "top-left":
		//	$('#image img').css('-webkit-transform','rotate('+(0-imageRotation)+'deg)');
		//	imageRotation =$('#image').css('-webkit-transform');
		break;
	case "right-top":
		$('#image img').css('-webkit-transform', 'rotate(90deg)');
		$('#image img').css('-moz-transform', 'rotate(90deg)');
		//			imageRotation =$('#image').css('-webkit-transform');
		//			alert("imageRotation "+imageRotation);
		break;
	case "bottom-right":
		$('#image img').css('-webkit-transform', 'rotate(180deg)');
		$('#image img').css('-moz-transform', 'rotate(90deg)');
		//			imageRotation =$('#image').css('-webkit-transform');
		break;
	case "left-bottom":
		$('#image img').css('-webkit-transform', 'rotate(270deg)');
		$('#image img').css('-moz-transform', 'rotate(90deg)');
		//			imageRotation =$('#image').css('-webkit-transform');
		break;
	}
	//	imageRotation =$('#image img').css('-webkit-transform');


	if (tvYear == "2011") {
		var top = $('#image').css('top')
			$('#openFile').prepend("<div id='blackDiv' style='position:absolute; height:top; background:black;'");
	}

	$('#image').css('visibility', 'visible');
	//start timer
	imageTimeStart = new Date().getTime();
	loading = false;

}

//Center the image in the screen (called after the image is loaded)
SceneImageScene.setPosition = function () {
	alert("set pos ");
	var containerHeight = $("#openFile").height();
	var containerWidth = $("#openFile").width();
	alert("0");
	if (imageFiles[imagePos].orientation == "right-top" || imageFiles[imagePos].orientation == "left-bottom") {
		alert("1");
		var totalHeight = imageArray[imagePos].naturalWidth;
		var totalWidth = imageArray[imagePos].naturalHeight;
		var height = imageArray[imagePos].height;
		var width = imageArray[imagePos].width;
		alert("height: " + height);
		alert("width: " + width);
		if (width > containerHeight) {
			height = imageArray[imagePos].height = containerHeight * containerHeight / width;
			width = imageArray[imagePos].width = containerHeight;
			alert("height: " + height);
			alert("width: " + width);
		}
	} else {
		alert("2");
		var totalHeight = imageArray[imagePos].naturalHeight;
		var totalWidth = imageArray[imagePos].naturalWidth;
		var height = imageArray[imagePos].height;
		var width = imageArray[imagePos].width;
	}
	alert("height: " + height);
	alert("width: " + width);
	alert("totalHeight: " + totalHeight);
	alert("totalWidth: " + totalWidth);

	alert("containerHeight " + containerHeight);
	alert("containerWidth " + containerWidth);

	//image width to fill the screen
	if (width < containerWidth && height < containerHeight) {
		if (16 / 9 < width / height) {
			imageArray[imagePos].width = containerWidth;
			imageArray[imagePos].height = containerWidth * height / width;
		} else {
			imageArray[imagePos].width = containerHeight * width / height;
			imageArray[imagePos].height = containerHeight;
		}
	}
	height = imageArray[imagePos].height;
	width = imageArray[imagePos].width;

	//Check image width/height ratio
	if ((16 / 9 < width / height) && (height > containerHeight || width > containerWidth)) {
		var top = Math.floor((containerHeight - (height * containerWidth / width)) / 2);
		$('#image').css('padding-top', top);
		$('#image').css('height', containerHeight);
	} else {
		if (height != undefined && height <= containerHeight && height != 0) {
			var top = Math.floor((containerHeight - height) / 2);
			$('#image').css('padding-top', top);
			$('#image').css('height', containerHeight);

		} else {
			$('#image').css('height', containerHeight);
			$('#image').css('padding-top', 0);
		}
	}

	//		}
	//	}
}

SceneImageScene.loadImage = function () {
	alert("loading: " + imagePos + "  " + imageArray[imagePos]);

	//show image or loading.
	//	if(imageArray[imagePos] != "loading" && imageArray[imagePos] != undefined){

	if (imageArray[imagePos] == undefined) {
		//		if(true){
		//			delete(imageArray);
		//			imageArray = new Array();
		//		}
		loading = true;
		$('#loadingImage').sfLoading('show');
		var l = imageFiles[imagePos].url || imageFiles[imagePos].href; //different browser handles it in different way
		//var link = l + "/" + imageFiles[imagePos].title;
		if (l.charAt(l.length - 1) == "1") {
			l = l.substring(0, l.lastIndexOf("1"));
			var link = l + "32772/" + folderFiles[pos].title;
		} else {
			var link = l + "?s=32772";
		}

		link = baxide.generateUrl(link);
		if (retry) {
			link = link + "&n=" + Math.random();
		} else {
			imageUrl[imagePos] = link;
			retry = false;
		}
		var img = null;
		img = document.createElement("img");
		img.src = "";
		alert("new image1 " + img.src);
		img.onload = function () {
			imageArray[imagePos] = img;
			SceneImageScene.load();
			img = null;
			delete(img);
		}
		img.onerror = function () {

			alert("the image couldn't be loaded. try again");
			alert("imageArray " + imageArray);
			alert("scene foc: " + sf.scene.getFocused());
			if (!sf.scene.getFocused('ImageScene')) {
				alert("return");
				return;
			}
			for (var i in imageArray) {
				alert("i " + i);
				imageArray[i] = null;
				delete(imageArray[i]);
			}
			alert("imageArray " + imageArray);
			imageArray = null;
			alert("imageArray " + imageArray);
			delete(imageArray);
			alert("imageArray " + imageArray);
			imageArray = new Array();
			retry = true;
			if (imgElement.firstChild != null) {
				alert("remove first element");
				if (imgElement.deleteChild)
					imgElement.deleteChild(imgElement.firstChild);
				else
					var del = imgElement.removeChild(imgElement.firstChild);
			}
			SceneImageScene.loadImage();

		}
		img.src = link;
		alert("new image2 " + img.src);
		//		imageArray[imagePos]=img;
		l = null;
		link = null;
		//		imageArray[imagePos]=img; //add id to the array

		alert("image: " + img);
	} else {
		SceneImageScene.showImage();
		SceneImageScene.preLoad();

	}


}

SceneImageScene.load = function () {
	alert("Image loaded");

	SceneImageScene.showImage();
	if (imageArray[(imagePos + 1)] == undefined && playing) {
		for (var i in imageArray) {
			alert("i " + i);
			imageArray[i] = null;
			delete(imageArray[i]);
		}
		alert("imageArray " + imageArray);
		imageArray = null;
		alert("imageArray " + imageArray);
		delete(imageArray);
		alert("imageArray " + imageArray);
		imageArray = new Array();
		SceneImageScene.loadNextImage((imagePos + 1));
	} else {
		SceneImageScene.preLoad();
	}
}

SceneImageScene.preLoad = function () {
	//Preload rest of images
	alert("number pre load: " + numberPreLoad);

	var j = 1;
	for (j = 1; j <= numberPreLoad; j++) { //numberPreLoad
		try {
			SceneImageScene.loadNextImage((imagePos + j));
		} catch (error) {}
		if (!playing) {
			try {
				SceneImageScene.loadNextImage((imagePos - j));
			} catch (error) {}
		}
	}
}

SceneImageScene.loadNextImage = function (position) {
	alert(position);
	if (imageArray[position] == undefined && position >= 0 && position < imageFiles.length) { //if its not already loaded and the position is between the limits
		var l = imageFiles[position].url || imageFiles[position].href; //different browser handles it in different way
		//var link = l + "/" + imageFiles[position].title;
		//		var link = l.slice(0,(l.length-1));
		if (l.charAt(l.length - 1) == "1") {
			l = l.substring(0, l.lastIndexOf("1"));
			var link = l + "32772/" + imageFiles[position].title;
		} else {
			var link = l + "?s=32772";
		}
		//		link = link + "32772/" + imageFiles[position].title;
		alert("get: " + link);
		link = baxide.generateUrl(link);
		var newImg = document.createElement("img");

		imageUrl[position] = link;
		newImg.onload = function () {
			alert("Image loaded");
			imageArray[position] = newImg;
			newImg = null;
			delete(newImg);
			alert("position: " + position + "   imagePos: " + imagePos);
			if (position == imagePos) {
				SceneImageScene.showImage();
			}
		};

		newImg.onerror = function () {
			alert("the image couldn't be preloaded. try again");
			alert("imageArray " + imageArray);
			alert("imageUrl " + imageUrl);
		}
		alert("newimg.src");
		newImg.src = link;
		alert("newimg.src");
		//		imageArray[position] = null;
		//		imageArray[position] = newImg; //add id to the array
		//		newImg = null;

	}
}

SceneImageScene.slideshow = function () {
	if (!stop) {
		alert('Next Image');
		if (imagePos == (imageFiles.length - 1)) {
			imagePos = 0;
		} else {
			imagePos++;
		}
		SceneImageScene.loadImage();
	}
}

//hide help bar after 3 sec of last button pressed
SceneImageScene.hideHelpBar = function () {
	if (lastTimeButtonPressed == null || Date.now() >= (lastTimeButtonPressed + 3000)) {
		$('#svecKeyHelp_image').css('visibility', 'hidden')
	}
}
