function SceneVideoScene(options) {
	this.options = options;
	var VideoPlayer;

}
var initialTime2;
var first = true;
var bufferComplete = false;
var bufferstart;
var popupInputPointer;
var numberOfInterruptionsInReproduction = 0; //every time the buffer is empty, increase this
var Video = {
	plugin : null,
	duration : null,
	lastTimeButtonPressed : null,
	buttonPressed : null,
	interval : null,
	link : null,
	stop : false,
	moving : false,
	speed : 1,
	initialBuffer : null,
	lastTime : null,
	failCounter : null,
	message : null,
	startPlaying : false
}

SceneVideoScene.prototype.initialize = function () {
	alert("SceneVideoScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	Video.plugin = sf.core.plugin('PLAYER');
	popupInputPointer = 0;
}

SceneVideoScene.prototype.handleShow = function () {
	alert("SceneVideoScene.handleShow()");
	// this function will be called when the scene manager show this scene

}

SceneVideoScene.prototype.handleHide = function () {
	alert("SceneVideoScene.handleHide()");
	// this function will be called when the scene manager hide this scene
	//Video = null;
	pluginAPI.setOnScreenSaver();
	//	sf.key.registerKey(sf.key.UP);
	//	sf.key.registerKey(sf.key.DOWN);
	$("#videoProgressBar").css('width', '0px');
	$("#videoCurrentDuration").html("00:00:00 /");
	$("#videoDuration").html("00:00:00");
	alert("video scene: " + $("#SceneVideoScene").css('visibility'));
	alert("drive scene: " + $("#SceneDriveScene").css('visibility'));
	$("#SceneDriveScene").css('visibility', 'visible');
	$("#SceneVideoScene").css('visibility', 'hidden');
	$("#_plugin_id_PLAYER").css('visibility', 'hidden');
	if (!sf.scene.getVisible('DriveScene')) {
		sf.scene.show('DriveScene');
	}
	sf.scene.focus('DriveScene', true);
	alert("video scene: " + $("#SceneVideoScene").css('visibility'));
	alert("drive scene: " + $("#SceneDriveScene").css('visibility'));

}

SceneVideoScene.prototype.handleFocus = function () {
	alert("SceneVideoScene.handleFocus()");
	$("#SceneVideoScene").css('visibility', 'visible');
	// this function will be called when the scene manager focus this scene
	numberOfInterruptionsInReproduction = 0;
	bufferComplete = false;
	first = true;
	var pos = currentFocused - fold.length;
	var l = folderFiles[pos].url || folderFiles[pos].href;
	if (l.charAt(l.length - 1) != "/") {
		var link = l;
	} else {
		var link = l + "/" + folderFiles[pos].title;
	}
	Video.link = baxide.generateUrl(link);
	alert("video Link: " + Video.link);
	Video.init(Video.link);
	Video.buttonPressed = "play";
	Video.showControls();
	$("#_plugin_id_PLAYER").css('visibility', 'visible');
	$("#_plugin_id_PLAYER").css('height', '720px');
	$("#_plugin_id_PLAYER").css('width', '1280px');
	//	$("#_plugin_id_PLAYER").css('height','540px');
	//	$("#_plugin_id_PLAYER").css('width','960px');
	var width = sf.env.getScreenSize().width;
	var left = (width / 2 - ($("#videoInfo").width() / 2));
	left = left + "px";
	alert("left: " + left)
	$("#videoInfo").css("left", left);
	$("#buffering").css('visibility', 'hidden');
	$(".videoTitle").html(folderFiles[pos].title);
	Video.moving = false;
	Video.initialBuffer = videoBufferSize;
	//	sf.key.unregisterKey(sf.key.UP);
	//	sf.key.unregisterKey(sf.key.DOWN);
	Video.failCounter = 0;
	Video.message = "";
	$("#videoProgressBar").css('width', '0px');
	$("#videoCurrentDuration").html("00:00:00 /");

}

SceneVideoScene.prototype.handleBlur = function () {
	alert("SceneVideoScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneVideoScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneVideoScene.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued

	Video.lastTimeButtonPressed = Date.now();
	//	Video.moving = false;
	switch (keyCode) {
	case sf.key.RETURN:
	case sf.key.PANEL_RETURN:
		Video.moving = false;
		alert("RETURN");
		Video.buttonPressed = null;
		Video.interval = clearInterval(Video.interval);
		Video.plugin.Stop();
		sf.scene.hide('VideoScene');

		sf.key.preventDefault();
		break;

	case sf.key.PLAY:
		alert("PLAY");
		Video.interval = clearInterval(Video.interval);
		//			if(Video.moving){
		//				Video.plugin.SetInitialBuffer(this.initialBuffer);
		//			}
		

		if (Video.stop) {
			Video.stop = false;
			Video.init(Video.link);

		} else {
			Video.plugin.Resume();
		}
		Video.moving = true;
		Video.buttonPressed = "play";
		Video.showControls();
		Video.speed = 1;

		//			Video.plugin.SetPlaybackSpeed(Video.speed);
		break;

	case sf.key.STOP:
		alert("STOP");
		Video.buttonPressed = "stop";
		Video.interval = clearInterval(Video.interval);
		Video.showControls();
		Video.stop = Video.plugin.Stop();
		Video.moving = false;
		sf.scene.hide('VideoScene');
		if (!sf.scene.getVisible('DriveScene')) {
			sf.scene.show('DriveScene');
		}
		sf.scene.focus('DriveScene');
		break;

	case sf.key.PAUSE:
		//if(Video.moving){
			
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			alert(" VIDEO PAUSE");
			Video.buttonPressed = "pause";
			Video.interval = clearInterval(Video.interval);
			Video.plugin.Pause();
			Video.speed = 1;
			Video.moving = false;
		//}
		Video.showControls();
		break;

	case sf.key.FF:
		alert("FF");
		Video.buttonPressed = "ff";
		//			Video.plugin.SetInitialBuffer(256);
		if (Video.speed < 16 && Video.speed > 0) {
			Video.speed = Video.speed * 2;
		}
		if (Video.speed < 0) {
			if (Video.speed == -1) {
				Video.speed = 1;
			} else {
				Video.speed = Video.speed / 2;
			}
		}

		Video.showControls();
		alert("Video.speed: " + Video.speed);
		//				Video.plugin.JumpForward(1);
		Video.plugin.Pause();
		Video.moving = true;
		if (Video.interval == undefined) {
			Video.interval = setInterval(function () {
					Video.moveTime(true);
				}, 100);
		}
		//			var v = Video.plugin.SetPlaybackSpeed(Video.speed);
		//           alert("v: "+v);
		alert("Video.interval: " + Video.interval);
		break;

	case sf.key.REW:
		alert("REW");
		Video.buttonPressed = "rew";
		//			Video.plugin.SetInitialBuffer(256);
		if (Video.speed > -16 && Video.speed < 0) {
			Video.speed = Video.speed * 2;
		}
		if (Video.speed > 0) {
			if (Video.speed == 1) {
				Video.speed = -1;
			} else {
				Video.speed = Video.speed / 2;
			}
		}
		Video.showControls();
		Video.plugin.Pause();
		Video.moving = true;
		if (Video.interval == undefined) {
			Video.interval = setInterval(function () {
					Video.moveTime(false);
				}, 100);
		}
		//			Video.plugin.JumpBackward(10);
		//			Video.plugin.SetPlaybackSpeed(Video.speed);

		break;

	case sf.key.VOL_UP:
	case sf.key.PANEL_VOL_UP:
		alert("VOL_UP");
		deviceapis.audiocontrol.setVolumeUp();
		Video.showControls();
		//            if(this.mute == 0)
		//                Audio.setRelativeVolume(0);
		break;

	case sf.key.VOL_DOWN:
	case sf.key.PANEL_VOL_DOWN:
		alert("VOL_DOWN");
		deviceapis.audiocontrol.setVolumeDown();
		Video.showControls();
		//            if(this.mute == 0)
		//                Audio.setRelativeVolume(1);
		break;

	case sf.key.ENTER:
	case sf.key.PANEL_ENTER:
		alert("ENTER");
		//            this.toggleMode();
		break;

	case sf.key.MUTE:
		alert("MUTE");
		if (deviceapis.audiocontrol.getMute() == true) {
			deviceapis.audiocontrol.setMute(false);

		} else {
			deviceapis.audiocontrol.setMute(true);
		}
		Video.showControls();
		break;

	case sf.key.BLUE:
		alert("Go To: ");
		popupInputPointer = 0;
		Video.plugin.Pause();
		Video.moving = false;
		Video.goToPopUp();
		Video.showControls();

		break;

	default:
		Video.showControls();
		break;

	}
}

Video.showControls = function () {
	//	$("#videoInfo").css('visibility','visible');
	if ($("#videoInfo").css("bottom") == "-81px") {
		$("#videoInfo").animate({
			"bottom" : "0px"
		}, "fast");
	}

	//Set focus in the control button pressed
	switch (Video.buttonPressed) {
	case "play":
		$(".play").css('border', '1px solid yellow');
		$(".pause").css('border', '');
		$(".stop").css('border', '');
		$(".fwd").css('border', '');
		$(".rew").css('border', '');
		break;
	case "pause":
		$(".pause").css('border', '1px solid yellow');
		$(".play").css('border', '');
		$(".stop").css('border', '');
		$(".fwd").css('border', '');
		$(".rew").css('border', '');
		break;
	case "stop":
		$(".stop").css('border', '1px solid yellow');
		$(".play").css('border', '');
		$(".pause").css('border', '');
		$(".fwd").css('border', '');
		$(".rew").css('border', '');
		$("#buffering").css('visibility', 'hidden');
		break;
	case "ff":
		$(".fwd").css('border', '1px solid yellow');
		$(".play").css('border', '');
		$(".stop").css('border', '');
		$(".pause").css('border', '');
		$(".rew").css('border', '');
		break;
	case "rew":
		$(".rew").css('border', '1px solid yellow');
		$(".play").css('border', '');
		$(".stop").css('border', '');
		$(".fwd").css('border', '');
		$(".pause").css('border', '');
		break;
	}

	if (window.deviceapis.audiocontrol.getMute() == true) {
		$(".vol").attr('src', 'images/control/mute.png');
		$(".volume").html("0%");
	} else {
		$(".vol").attr('src', 'images/control/volume.png');
		$(".volume").html(window.deviceapis.audiocontrol.getVolume() + "%");
	}
	setTimeout("Video.hideControls();", 4000);
}

//Hide the controls from the screen 4 sec after the last button is pressed
Video.hideControls = function () {
	if (Video.buttonPressed != "rew" && Video.buttonPressed != "ff") {
		alert("hide: " + (Date.now() - this.lastTimeButtonPressed));
		if (this.lastTimeButtonPressed == null || Date.now() >= (this.lastTimeButtonPressed + 4000)) {
			//$('#videoInfo').css('visibility','hidden');
			$("#videoInfo").animate({
				"bottom" : "-81px"
			}, "fast");

		}
	}
}

//Method to move the video time reproduction. Used in ff and rwd
Video.moveTime = function (forward) {
	alert("video move " + Video.moving);
	if (Video.moving) {
		alert("move video position: " + Video.speed);
		if (forward) {
			Video.plugin.JumpForward(Video.speed);
		} else {
			Video.plugin.JumpBackward( - (Video.speed - 2));
		}
	}
}

//go to a specific position in a video.
Video.goToPos = function (time) {
	sf.scene.returnFocus();
	alert("go to pos: " + time + "  from: " + this.lastTime + "    totaldur: " + Video.duration);
	if (time > 0 && time < Video.duration) {
		var currentSec = Math.floor(this.lastTime / 1000);
		if (time - currentSec > 0) {
			alert("jump forward " + (time - currentSec));
			Video.plugin.JumpForward(time - currentSec);
		} else {
			alert("jump back: " + (currentSec - time));
			Video.plugin.JumpBackward(currentSec - time);
		}
		//Video.plugin.Resume();
	}
}

Video.init = function (link) {
	this.plugin.InitPlayer(link);
	//this.plugin.SetPlayerProperty(5, "MP3", 0)
	this.plugin.SetInitialBuffer(videoBufferSize);
	this.plugin.SetPendingBuffer(videoBufferSize);
	//	this.plugin.SetTotalBufferSize(videoBufferSize*10);
	alert("videoBufferSize " + videoBufferSize);
	this.initialBuffer = videoBufferSize;
	//this.plugin.SetTotalBufferSize(videoBufferSize);
	this.plugin.SetDisplayArea(0, 0, 960, 540);

	this.plugin.OnCurrentPlayTime = 'Video.setCurTime';
	this.plugin.OnStreamInfoReady = 'Video.setInfo';
	this.plugin.OnBufferingStart = 'Video.onBufferingStart';
	this.plugin.OnBufferingProgress = 'Video.onBufferingProgress';
	this.plugin.OnBufferingComplete = 'Video.onBufferingComplete';
	this.plugin.OnNetworkDisconnected = 'Video.onNetworkDisconnected';
	this.plugin.OnConnectionFailed = 'Video.onConnectionFailed';
	this.plugin.OnRenderError = 'Video.onRenderError';

	bufferstart = (new Date()).getTime();
	pluginAPI.setOffScreenSaver();
	$("#buffering").css('visibility', 'visible');
	$("#buffering").html("Loading...");
	this.plugin.StartPlayback();
	Video.moving = true;

}

Video.setCurTime = function (time) {
	alert("Current time: " + time + " last time" + this.lastTime);
	if (Video.buttonPressed == "pause"){
		Video.plugin.Pause();
		return;
	}
	if (time == 0 && Video.buttonPressed == "rew") {
		Video.interval = clearInterval(Video.interval);
		Video.buttonPressed = "pause";
	}
	if (this.lastTime != null && this.lastTime - time === 0) {
		Video.failCounter++;
		if (Video.failCounter == 10) {
			Video.plugin.Stop();
			controller.videoError(STR_VIDEO_ERROR_POPUP + "</br>" + Video.message);
		}
	} else {
		this.lastTime = time;
		Video.failCounter = 0;

		$("#videoCurrentDuration").html(controller.getTime(time) + " /");
		//Progress bar
		var barlength = $('#videoProgressBackground').width();
		alert("barlength " + barlength);
		var progress = (time / this.duration * barlength) + 'px'; // barlength = progress bar width
		$("#videoProgressBar").css('width', progress);

		alert("this.duration: " + this.duration);
		if (time >= this.duration) {
			Video.plugin.Stop();
			sf.scene.hide('VideoScene');
			if (!sf.scene.getVisible('DriveScene')) {
				sf.scene.show('DriveScene');
			}
			sf.scene.focus('DriveScene');
		}
	}
}

//Get the video info. Update Buffer size
Video.setInfo = function () {
	this.duration = this.plugin.GetDuration();
	$("#videoDuration").html(controller.getTime(this.duration)); //ms to seconds

	var sizeArr = folderFiles[pos].size.split(" ");
	var size = 0;
	if (folderFiles[pos].size.indexOf("B") != -1) {
		switch (folderFiles[pos].size.split(" ")[1]) {
		case 'KB':
			size = folderFiles[pos].size.split(" ")[0] * 1024 * 8;
			break;
		case 'MB':
			size = folderFiles[pos].size.split(" ")[0] * 1024 * 1024 * 8;
			break;
		case 'GB':
			size = folderFiles[pos].size.split(" ")[0] * 1024 * 1024 * 1024 * 8;
			break;
		}
	} else {
		size = folderFiles[pos].size * 8;
	}
	var videoBitRate = 1000 * size / this.duration;
	alert("videoBitRate: " + videoBitRate + " bps");
	//	alert("Math.floor(videoBitRate/50000): "+Math.floor(videoBitRate/50000));
	//	switch(Math.floor(videoBitRate/50000)){
	//		case 1:
	//			videoBufferSize = videoBufferSize*2; 		 //in bytes
	//			break;
	//		case 2:
	//			videoBufferSize = videoBufferSize*4;
	//			break;
	//		case 3:
	//			videoBufferSize = videoBufferSize*6;
	//			break;
	//		case 4:
	//			videoBufferSize = videoBufferSize*8;
	//			break;
	//		default:
	//			videoBufferSize = videoBufferSize*16;
	//			break;
	//	}

	//	videoBufferSize = videoBitRate *5; // The buffer is 5 seconds of video reproduction
	//	alert("videoBufferSize "+videoBufferSize );
	//var sizeBff = Math.min(videoBitRate * 5, 10 * 1024 * 1024);
	this.plugin.SetTotalBufferSize(videoBitRate * 5); // The buffer is 5 seconds of video reproduction
	alert("video bitrate: " + 1000 * size / this.duration + "  bps");

	alert("Video width: " + this.plugin.GetVideoHeight());

}

//Method called when the buffer is full. Hide the buffering from the screen.
Video.onBufferingComplete = function () {
	var endTime = (new Date()).getTime();
	$("#buffering").css('visibility', 'hidden');
	//	if(Video.moving){
	//		Video.moving = false;
	//	}
	bufferComplete = true;
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	alert("Video.buttonPressed "+Video.buttonPressed );
	if (Video.buttonPressed == "play"){
		Video.plugin.Resume();
		Video.moving = true;
	}

	
	var time = (endTime - initialTime);
	var speed = ((1000 * 8 * this.initialBuffer) / time);
	alert("Buffering complete. time needed: " + time + " speed: " + speed + "bps  buffer size: " + this.initialBuffer);
	
	Video.startPlaying = true;

}

//Method called while buffering
Video.onBufferingProgress = function (percent) {
	alert("Buffering:" + percent + "%");

	//Estimate network speed
	if (!first) {
		var endTime = (new Date()).getTime();
		alert("endTIme: " + endTime + " initial:" + initialTime2);
		var time = (endTime - initialTime2);
		alert("time: " + time);
		var speed = ((1000 * 8 * videoBufferSize) / (endTime - initialTime2)) / 1024 / 1024;
		var size = videoBufferSize / (percent - previousPercent);
		alert("Buffering " + percent + ". time needed: " + time + " speed: " + speed + "  buffer size: " + videoBufferSize);

	}
	first = false;
	initialTime2 = (new Date()).getTime();
	previousPercent = percent;

	//double the size of the buffer if more than 2 interruptions appear
	if (bufferComplete == true) {
		Video.plugin.Pause();
		numberOfInterruptionsInReproduction++;
		bufferComplete = false;
		if (numberOfInterruptionsInReproduction > 2) {
			videoBufferSize = videoBufferSize * 2;
			this.plugin.SetTotalBufferSize(videoBufferSize);
		}
	}

	// show buffering percentage in screen.availHeight Only if not rewind or fast forward
	if (Video.buttonPressed != "rew" && Video.buttonPressed != "ff") {
		$("#buffering").html("Buffering..." + percent + "%");
		$("#buffering").css('visibility', 'visible');
	}
}

//Method called when the buffering start. Not working in 2011 devices
Video.onBufferingStart = function () {
	Video.moving = false;
	alert("Buffer start");
	$("#buffering").css('visibility', 'visible');
	$("#buffering").html("Buffering...");
	initialTime = (new Date()).getTime();
	initialTime2 = initialTime;

}

//Display a message if the network has been disconnected.
Video.onNetworkDisconnected = function () {
	Video.buttonPressed = "stop";
	Video.moving = false;
	Video.showControls();
	Video.plugin.Stop();
	controller.videoError(STR_NETWORK_DISCONNECTED_POPUP);
}

//Display a message if the connection fails.
Video.onConnectionFailed = function () {
	alert("Connection failed");
	Video.buttonPressed = "stop";
	Video.showControls();
	Video.plugin.Stop();
	controller.videoError(STR_CONNECTION_FAILED_POPUP);
	//	$('.video_error_popup').sfPopup({
	//		text: STR_CONNECTION_FAILED_POPUP,
	//		buttons: ["OK"],
	//		defaultFocus: 0,
	//		callback: function logoutCallback(selectedIndex){
	//		sf.scene.hide('VideoScene');
	//			if(!sf.scene.getVisible('DriveScene')){
	//				sf.scene.show('DriveScene');
	//			}
	//			sf.scene.focus('DriveScene');
	//		}
	//	});
	//	$('.video_error_popup').sfPopup('show');
}

//Display a message if the network has been disconnected.
Video.onRenderError = function (errorType) {
	alert("Render error " + errorType);
	var msg = "";
	switch (errorType) {
	case "1":
		msg = STR_RENDER_ERROR_POPUP_1;
		break;
	case "2":
		msg = STR_RENDER_ERROR_POPUP_2;
		break;
	case "3":
		msg = STR_RENDER_ERROR_POPUP_3;
		break;
	case "4":
		msg = STR_RENDER_ERROR_POPUP_4;
		break;
	default:
		msg = STR_RENDER_ERROR_POPUP;
		break;
	}
	Video.message = Video.message + msg + "</br>";
	//	Video.showControls();
	//	Video.plugin.Stop();
	//	controller.videoError(msg);

	//	$('.video_error_popup').sfPopup({
	//		text: msg,
	//		buttons: ["OK"],
	//		defaultFocus: 0,
	//		callback: function logoutCallback(selectedIndex){
	//		sf.scene.hide('VideoScene');
	//			if(!sf.scene.getVisible('DriveScene')){
	//				sf.scene.show('DriveScene');
	//			}
	//			sf.scene.focus('DriveScene');
	//		}
	//	});
	//	$('.video_error_popup').sfPopup('show');
}

Video.goToPopUp = function () {

	if(!Video.startPlaying) return;
	
	$('#goto_popup').sfPopup({
		title : "Move to:",
		text : "Hour:  </br></br>Minutes:  </br></br>Seconds: </br>",
		buttons : [STR_OK, STR_CANCEL],
		timeout : 0,
		defaultFocus : 1,
		callback : function newFolderCallback(selectedIndex) {
			alert("popup_callback");
			if (selectedIndex == 0) {
				var seconds = document.getElementById("secondInput").value;
				var minutes = document.getElementById("minuteInput").value;
				var hours = document.getElementById("hourInput").value;

				Video.goToPos(utils.timeToS(hours, minutes, seconds));
			}

		},
		onkeydown : function (keyCode) {
			alert("KEYDOWN : " + keyCode);
			switch (keyCode) {
			case sf.key.UP:
				document.getElementById("secondInput").focus();						
				//$('#newFolder_popup').sfPopup("option", "focus", "0");
				break;

			case sf.key.LEFT:
				$('#goto_popup').sfPopup("option", "focus", "0");
				break;

			case sf.key.RIGHT:
				$('#goto_popup').sfPopup("option", "focus", "1");
				break;
			case sf.key.ENTER:
				$('#goto_popup').sfPopup('hide');
				break;
			}
		}
	});
	$('#goto_popup').sfPopup('show');
	$('#goto_popup').append('<input id="hourInput" type="text" size="2" maxlength="2"/> :');
	$('#goto_popup').append('<input id="minuteInput" type="text" size="2" maxlength="2"/> :');
	$('#goto_popup').append('<input id="secondInput" type="text" size="2"  maxlength="2"/>');
	var ime_hour = new IMEShell("hourInput", callback_goto, "en");
	var ime_minute = new IMEShell("minuteInput", callback_goto, "en");
	var ime_second = new IMEShell("secondInput", callback_goto, "en");

	ime_hour.setString("00");
	ime_minute.setString("00");
	ime_second.setString("00");
	var xPosition;
	switch (sf.env.getResolution()) {
	case '540p':
		xPosition = 680;
		break;
	case '720p':
		xPosition = 880;
		break;
	case '1080p':
		xPosition = 1080;
		break;
	}
	ime_hour.setKeypadPos(xPosition, 70, 9);
	ime_minute.setKeypadPos(xPosition, 70, 9);
	ime_second.setKeypadPos(xPosition, 70, 9);
	document.getElementById("hourInput").focus(); //focus the hour title
	$("#ime_keypad").css('opacity', '1');
	$("#ime_keypad").css('z-index', '99');
}

function callback_goto(cb) { //popup callback function
	alert("callback called");
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		alert("down ");
		popupInputPointer++;
		setInputFocus();
		sf.key.preventDefault();
		return false;
	});
	//	cb.setKeyFunc(sf.key.ENTER, function(keyCode) { document.getElementById("newFolder").blur(); sf.scene.returnFocus(); $('#newFolder_popup').sfPopup('show');  return false; } );
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("hourInput").blur();
		sf.scene.returnFocus();
		$('#goto_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});
	//	cb.setKeyFunc(sf.key.RIGHT, function(keyCode) {alert("right"); return false;});
	//	cb.setKeyFunc(sf.key.LEFT, function(keyCode) {alert("left"); return false;});
	cb.setKeyFunc(sf.key.UP, function (keyCode) {
		alert("up ");
		popupInputPointer--;
		setInputFocus();
		sf.key.preventDefault();
		return false;
	});
	//	cb.setKeyFunc(sf.key.EXIT, function(keyCode) {alert("exit"); sf.core.exit(true); });
}

setInputFocus = function () {
	switch (popupInputPointer) {
	case 0:
		document.getElementById("secondInput").blur();
		document.getElementById("minuteInput").blur();
		document.getElementById("hourInput").focus();
		break;
	case 1:
		document.getElementById("secondInput").blur();
		document.getElementById("hourInput").blur();
		document.getElementById("minuteInput").focus();
		break;
	case 2:
		document.getElementById("hourInput").blur();
		document.getElementById("minuteInput").blur();
		document.getElementById("secondInput").focus();
		break;
	default:
		document.getElementById("secondInput").blur();
		document.getElementById("minuteInput").blur();
		document.getElementById("hourInput").blur();
		sf.scene.returnFocus();
		$('#goto_popup').sfPopup('show');
		break;
	}
}
