function SceneFolderScene(options) {
	this.options = options;
}

var folderSelected;
var dirRoute = null;
var idRoute = null;


SceneFolderScene.prototype.initialize = function () {
	alert("SceneFolderScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called

	$('#svecKeyHelp_folder').sfKeyHelp({
		'user' : states.username,
		'updown' : 'UpDown',
		'leftRight' : 'Open Folder',
		'enter' : 'Move/Copy',
		'return' : 'Close'
	});

}

SceneFolderScene.prototype.handleShow = function () {
	alert("SceneFolderScene.handleShow()");
	// this function will be called when the scene manager show this scene

	folderSelected = null;
	dirRoute = null;
	idRoute = null;
}

SceneFolderScene.prototype.handleHide = function () {
	alert("SceneFolderScene.handleHide()");
	// this function will be called when the scene manager hide this scene
}

SceneFolderScene.prototype.handleFocus = function () {
	alert("SceneFolderScene.handleFocus()");
	// this function will be called when the scene manager focus this scene

	//$("#route").after("<div id='folderList'></div>");
	alert("dirRoute " + dirRoute + "  idRoute " + idRoute + " route " + route);
	//	dirRoute = route;
	//dirRoute = route.toString().replace(/ , /g, "/");
	dirRoute = route.toString().replace(/,/g, "/ ");
	alert("dirRoute " + dirRoute + "  idRoute " + idRoute + " route " + route);
	idRoute = new Array();
	idRoute = folderIdTree.slice(0);
	alert("dirRoute " + dirRoute + "  idRoute " + idRoute + " route " + route);
	

	controller.expandFolder(idRoute[idRoute.length - 1]);
	//	SceneFolderScene.loadList();
	SceneFolderScene.prototype.dir(null);

}

SceneFolderScene.prototype.handleBlur = function () {
	alert("SceneFolderScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
	dirRoute = null;
	folderSelected = null;
}

SceneFolderScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneFolderScene.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued


	switch (keyCode) {
	case sf.key.LEFT:
		//Parent Folder
		alert("idRoute " + idRoute);
		if (idRoute.length > 1) {
			alert("folder id: " + folderIdTree);
			idRoute.pop();
			alert("folder id: " + folderIdTree);
			var id = idRoute[(idRoute.length - 1)];
			//idRoute.push(id);
			//				var level = folderTree[4][$('#folderList').sfList('getIndex')] - 1 ;
			//				alert("folder. id: "+id+"  level "+level);
			controller.expandFolder(id);
			alert("folder id: " + folderIdTree);
			SceneFolderScene.prototype.dir("back");
			alert("folder id: " + folderIdTree);
		}
		break;
	case sf.key.RIGHT:
		//expand folder
		var id = folderTree[1][$('#folderList').sfList('getIndex')];
		//			var level = folderTree[4][$('#folderList').sfList('getIndex')] +1 ;
		var title = folderTree[0][$('#folderList').sfList('getIndex')];
		alert("idRoute " + idRoute);
		//			alert("folder. id: "+id+"  level "+level);
		if (id != undefined) {
			idRoute.push(id);
			controller.expandFolder(id);
			SceneFolderScene.prototype.dir(title);
		}
		break;
	case sf.key.UP:
		$('#svecVertical_scrollbar').sfScroll('prev');
		var idx = $('#folderList').sfList('getIndex');
		alert("idx = " + idx);
		if (idx == 0) {
			//$('#folderList').sfScroll('move', folderTree[0].length-1);
			//$('#folderList').sfList('move', folderTree[0].length-1);
			break;
		}
		$('#folderList').sfList('prev');
		break;
	case sf.key.DOWN:
		$('#svecVertical_scrollbar').sfScroll('next');
		var idx = $('#folderList').sfList('getIndex');
		alert("idx = " + idx);
		if (idx == folderTree[0].length - 1) {
			//	$('#folderList').sfScroll('move', 0);
			//	$('#folderList').sfList('move', 0);
			break;
		}
		$('#folderList').sfList('next');
		break;

	case sf.key.ENTER:
		folderSelected = $('#folderList').sfList('getIndex');
		alert("currentFocused " + currentFocused);
		sf.scene.hide('FolderScene');

		if (copy)
			controller.copyItems(selectedItems, folderTree[1][folderSelected]);

		if (move)
			controller.moveItems(selectedItems, folderTree[1][folderSelected]);

		if (!sf.scene.getVisible('DriveScene'))
			sf.scene.show('DriveScene');

		//sf.scene.focus('DriveScene', true);
		
		break;

	case sf.key.RETURN:
		alert("hide scene");
		controller.unSelectAll();
		sf.scene.hide('FolderScene');
		sf.scene.focus('DriveScene', true);
		sf.key.preventDefault();
		break;
	}
}

SceneFolderScene.loadList = function () {
	alert(folderTree[0]);
	$("#folderList").remove();
	$("#route").after("<div id='folderList'></div>");
	$('#folderList').sfList({
		data : folderTree[0],
		itemsPerPage : '10'
	});
	$('#folderList').sfList('focus');
	$('#svecVertical_scrollbar').sfScroll({
		pages : folderTree[0].length
	});
	$('#svecVertical_scrollbar').sfScroll('move', 0);
	$('#svecVertical_scrollbar').sfScroll('show');

	//$('#svecVertical_scrollbar').sfScroll('focus');
}

SceneFolderScene.prototype.dir = function (title) {
	alert("this.dir " + dirRoute + "  title " + title);
	if (title != null) {
		if (title != "back") {
			dirRoute += "/ " + title;
		} else {
			var pos = dirRoute.lastIndexOf("/ ");
			if (pos !=  - 1) {
				dirRoute = dirRoute.substring(0, dirRoute.lastIndexOf("/ "));
			}
		}
	}
	this.displayRoute();
	alert("this.dir " + dirRoute);

}

SceneFolderScene.prototype.displayRoute = function(){
	var displayedRoute = null;
	if(idRoute.length > 3){
		var t1 =  dirRoute.substring(0, dirRoute.lastIndexOf("/ "));
		var t2 =  t1.substring(0, t1.lastIndexOf("/ "));
		//var t3 =  t2.substring(0, t2.lastIndexOf("/ "));
		displayedRoute = "..." + t2.substr(t2.lastIndexOf("/ ")) + t1.substr(t1.lastIndexOf("/ ")) + dirRoute.substr(dirRoute.lastIndexOf("/ ")) ;
	}else{
		displayedRoute = dirRoute;
	}
	$("#route").html("<span class='dir'>" + displayedRoute + "</span>");

}
