function SceneTextScene(options) {
	this.options = options;
}

var Text = {
	scrollSize : 70,
	pages : 0
};

SceneTextScene.prototype.initialize = function () {
	alert("SceneTextScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called

};

SceneTextScene.prototype.handleShow = function () {
	alert("SceneTextScene.handleShow()");
	// this function will be called when the scene manager show this scene
	$('#svecKeyHelp_text').sfKeyHelp({
		'user' : states.username,
		'return' : STR_BACK
	});

};

SceneTextScene.prototype.handleHide = function () {
	$('#openTextFile').html("");
	$('#openTextScroll').sfScroll('hide');
	sf.scene.focus('DriveScene', true);
};

SceneTextScene.prototype.handleFocus = function (pos) {
	$('#openTextFile').html("");
	$('#openTextScroll').sfScroll('hide');
	$("#openTextFile").css("top", "0px");
	Text.pages = 0;
	controller.getTxtFile(folderFiles[pos].href);
};

SceneTextScene.prototype.handleBlur = function () {
	alert("SceneTextScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
};

SceneTextScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneTextScene.handleKeyDown(" + keyCode + ")");

	switch (keyCode) {
	case sf.key.RETURN:
	case sf.key.PANEL_RETURN:
		sf.scene.hide('TextScene');
		sf.key.preventDefault();
		break;

	case sf.key.UP:
		var DesPosition = $("#openTextFile").position().top;
		alert("up desposition: " + DesPosition);
		if (DesPosition < 0) {
			$("#openTextFile").css("top", DesPosition + Text.scrollSize);
			$('#openTextScroll').sfScroll('prev');
		} else {
			$('#openTextScroll').sfScroll('prev');
		}

		break;
	case sf.key.DOWN:
		var DesPosition = $("#openTextFile").position().top;
		alert("DesPosition " + DesPosition);
		var frame = document.getElementById("openTextFile_frame");
		var textSize = document.getElementById("openTextFile");
		alert("textSize.scrollHeight: " + textSize.scrollHeight);
		alert("frame.offsetHeight: " + frame.offsetHeight);
		if (textSize.scrollHeight - frame.offsetHeight > DesPosition * ( - 1)) {
			alert("top: " + (DesPosition - Text.scrollSize));
			$("#openTextFile").css("top", DesPosition - Text.scrollSize);
			$('#openTextScroll').sfScroll('next');
		} else {
			$('#openTextScroll').sfScroll('next');
		}
		break;
		// Music button handler:
	case sf.key.PLAY:
		alert("PLAY");
		if (playingAudio) {
			$("#musicPlay").attr("src", "images/control/media_play_green.png");
			$("#musicPause").attr("src", "images/control/media_pause.png");
			PlayerPlugin.Resume();
		} else {
			controller.playMusic();
		}

		break;

	case sf.key.STOP:
		alert("STOP");
		controller.stopAudio();

		break;

	case sf.key.PAUSE:
		alert("PAUSE");
		$("#musicPlay").attr("src", "images/control/media_play.png");
		$("#musicPause").attr("src", "images/control/media_pause_red.png");
		PlayerPlugin.Pause();
		break;

	case sf.key.FF:
		alert("FF: " + currentAudio + "  length: " + playQueue.length);
		$("#musicFF").attr("src", "images/control/media_step_forward_green.png");
		setTimeout('$("#musicFF").attr("src", "images/control/media_step_forward.png");', 1000);
		controller.playNextSong(1);
		break;

	case sf.key.REW:
		alert("RW");
		$("#musicRW").attr("src", "images/control/media_step_back_green.png");
		setTimeout('$("#musicRW").attr("src", "images/control/media_step_back.png");', 1000);
		controller.playNextSong( - 1);
		break;

	case sf.key.VOL_UP:
		alert("Vol up");
		deviceapis.audiocontrol.setVolumeUp();
		break;

	case sf.key.VOL_DOWN:
		alert("Vol down");
		deviceapis.audiocontrol.setVolumeDown();
		break;

	case sf.key.MUTE:
		alert("MUTE");
		if (deviceapis.audiocontrol.getMute() == true) {
			deviceapis.audiocontrol.setMute(false);
		} else {
			deviceapis.audiocontrol.setMute(true);
		}
		break;

	default:
		break;

	}
};

SceneTextScene.prototype.showScroll = function () {
	alert("SceneTextScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene

	var height = $("#openTextFile").height();
	if (height > 605) {
		Text.pages = (Math.ceil((parseInt(height) - 540) / Text.scrollSize));
		alert("this.pages : " + Text.pages);
		$('#openTextScroll').sfScroll({
			pages : Text.pages
		});
		$('#openTextScroll').sfScroll('move', 0);
		$('#openTextScroll').sfScroll('show');
	}
};
